// Includes I didn't make myself
#include <math.h>
#include <string>
#include "SDL/SDL.h"
#include "SDL/SDL_ttf.h"

// Includes I did make myself
#include "button.h"
#include "constants.h"
#include "functions.h"
#include "globals.h"

// Next: buttonsets

// Dit werkt alleen als daarna de logic functie niet meer wordt gerunned! Want dan wordt ie gewoon gelijk weer
// op normal gezet. Alleen renderen dus!
int cButton::setState(int state) {
    this->buttonState = state;

    return 0;
}

cButton::cButton(std::string caption, int x, int y, bool align, TTF_Font* font, int visibleStateF, int position) {
    SDL_Color black = {0, 0, 0}; // Define some colors.
    SDL_Color white = {255, 255, 255};
    SDL_Color grey = {180, 180, 180};

    this->caption = caption;                                                            // Save the button caption.
    this->captionSurface = TTF_RenderText_Shaded(font, caption.c_str(), black, white);  // Generate the click and neutral caption.
    this->captionSurfaceH = TTF_RenderText_Shaded(font, caption.c_str(), grey, white);  // Generate the hover caption.

    // If align is true, the right side of the button has to lie on 400 pixels (design reasons). If not, we use the given variable.
    if (align) {
        this->propsStandard.x = 470 - this->captionSurface->w;
    } else {
        this->propsStandard.x = x;
    }

    // Copy some more props and put them in propsHeader too, to make sure that when I use the wrong one things don't get messed up.
    this->propsStandard.y = y;
    this->propsStandard.w = this->captionSurface->w;
    this->propsStandard.h = this->captionSurface->h;

    // Figure out the header position
    this->propsHeader = this->propsStandard;
    this->propsHeader.x = 470 - this->captionSurface->w;
    this->propsHeader.y = 80;

    // Self explanation
    this->propsCurrent = this->propsStandard;
    this->currentState = position;
    this->targetState = 0;
    // this->visibleAtStart = visibleAtStart;
    this->visibleState = visibleStateF;

    this->fadeSurface = SDL_CreateRGBSurface(SDL_SWSURFACE, this->propsStandard.w, this->propsStandard.h, SCR_BPP, 0, 0, 0, 0);
    SDL_SetAlpha(this->fadeSurface,  SDL_SRCALPHA, 0);
    SDL_FillRect(this->fadeSurface, NULL, SDL_MapRGBA(screen->format, 255, 255, 255, 255));

    switch (this->visibleState) {
        case B_FADINGIN:
            startTimeV = SDL_GetTicks();
            break;
        case B_FADINGOUT:
            startTimeV = SDL_GetTicks();
            break;
        case B_INVISIBLE:
            break;
        case B_VISIBLE:
            break;
    }

    /*
    if (!visibleAtStart) {
        this->currentState = B_INVISIBLE;
        SDL_SetAlpha(this->fadeSurface, SDL_SRCALPHA, ((SDL_GetTicks() - this->startTime)/500.0)*255.0);
    }
    */
}

cButton::~cButton() {
    // Self explanation
    SDL_FreeSurface(this->captionSurface);
    SDL_FreeSurface(this->captionSurfaceH);
    SDL_FreeSurface(this->fadeSurface);
}

int cButton::logic(int mX, int mY, Uint8 mouseState) {
    // If the targetState was changed - ANIMATION
    if (this->targetState > 0) {
        if (this->targetState == B_HEADER) { // If the targetState is header
            if (SDL_GetTicks() - this->startTimeM >= B_MS) { // If the animation time is over, set the button to header state
                this->currentState = B_HEADER;
                this->targetState = 0;
                this->startTimeM = 0;

                this->propsCurrent = this->propsHeader;
            } else {
                this->propsCurrent.y = this->propsHeader.y + pow(((SDL_GetTicks() - this->startTimeM - B_MS) / B_MS), 2) * (this->propsStandard.y - this->propsHeader.y);
            }
        } else  if (this->targetState == B_STANDARD) {
            if (this->currentState == B_HEADER) { // If the button is resetting from header
                if (SDL_GetTicks() - this->startTimeM >= B_MS) { // If the animation time is over, set the button to header state
                    this->currentState = B_STANDARD;
                    this->targetState = 0;
                    this->startTimeM = 0;

                    this->propsCurrent = this->propsStandard;
                } else {
                    this->propsCurrent.y = this->propsHeader.y + pow(((SDL_GetTicks() - this->startTimeM) / B_MS), 2) * (this->propsStandard.y - this->propsHeader.y);
                }
            }
        }
    }

    switch (visibleState) {
        case B_VISIBLE:
            break;
        case B_INVISIBLE:
            break;
        case B_FADINGIN:
            if (SDL_GetTicks() - this->startTimeV >= B_MS) {
                this->visibleState = B_VISIBLE;
                this->startTimeV = 0;
                SDL_SetAlpha(this->fadeSurface, SDL_SRCALPHA, 0);
            } else {
                SDL_SetAlpha(this->fadeSurface, SDL_SRCALPHA, ((500 - (SDL_GetTicks() - this->startTimeV))/500.0)*255.0);
            }
            break;
        case B_FADINGOUT:
            if (SDL_GetTicks() - this->startTimeV >= B_MS) {
                this->visibleState = B_INVISIBLE;
                this->startTimeV = 0;
                SDL_SetAlpha(this->fadeSurface, SDL_SRCALPHA, 255);
            } else {
                SDL_SetAlpha(this->fadeSurface, SDL_SRCALPHA, ((SDL_GetTicks() - this->startTimeV)/500.0)*255.0);
            }
            break;
    }

    // If mouse is in the button area, make the current surface the hover surface
    this->buttonState = B_NEUTRAL;
    if (pointInRect(mX, mY, this->propsCurrent) && this->getState() == B_STANDARD && this->visibleState == B_VISIBLE) {
        this->buttonState = B_HOVER;
        // buttonLook = this->captionSurfaceH;
        // If the mouse is clicked too, revert to standard button
        if (mouseState & SDL_BUTTON(SDL_BUTTON_LEFT) && this->getState() == B_STANDARD) {
            this->buttonState = B_CLICK;
            // buttonLook = this->captionSurface;
        }
    } else {
        // Neutral state. Make button look normal (not in area and not clicked)
        this->buttonState = B_NEUTRAL;
        // buttonLook = this->captionSurface;
    }

    return this->buttonState;
}

int cButton::render() {
    SDL_Surface* buttonLook; // The surface which we will use for the button

    switch (this->buttonState) {
        case B_HOVER:
            buttonLook = this->captionSurfaceH;
            break;
        case B_CLICK:
            buttonLook = this->captionSurface;
            break;
        case B_NEUTRAL:
            buttonLook = this->captionSurface;
            break;
        default:
            buttonLook = this->captionSurface;
    }

    if (this->visibleState != B_INVISIBLE) {
        applySurface(buttonLook, screen, this->propsCurrent.x, this->propsCurrent.y);
    }

    if (this->visibleState == B_FADINGIN || this->visibleState == B_FADINGOUT) {
        applySurface(this->fadeSurface, screen, this->propsCurrent.x, this->propsCurrent.y);
    }

    return 0;
}

int cButton::makeHeader() {
    this->targetState = B_HEADER;
    this->startTimeM = SDL_GetTicks();
    return 0;
}

int cButton::makeStandard() {
    this->targetState = B_STANDARD;
    this->startTimeM = SDL_GetTicks();

    return 0;
}

int cButton::fadeOut() {
    this->visibleState = B_FADINGOUT;
    this->startTimeV = SDL_GetTicks();

    return 0;
}

int cButton::fadeIn() {
    this->visibleState = B_FADINGIN;
    this->startTimeV = SDL_GetTicks();

    return 0;
}
/*
int cButton::reset() {
    this->targetState = B_STANDARD;
    this->startTime = SDL_GetTicks();
    return 0;
}
*/

// ToStandard doesn't get assignerd.

int cButton::getState() {
    if (this->targetState > 0) {
        switch (this->targetState) {
            case B_INVISIBLE:
                return B_FADINGOUT;
            case B_HEADER:
                return B_TOHEADER;
            case B_STANDARD:
                switch (this->currentState) {
                    case B_INVISIBLE:
                        return B_FADINGIN;
                    case B_HEADER:
                        return B_TOSTANDARD;
                }
        }
    }

    return this->currentState;
}

int cButton::getButtonState() {
    return this->buttonState;
}

int cButton::getVisible() {
    return this->visibleState;
}
