// Includes I didn't make myself
#include "SDL/SDL.h"
#include "SDL/SDL_ttf.h"
#include <string>

#ifndef BUTTON_H
#define BUTTON_H

// Dit is de button class die ik eind zomervakantie gemaakt heb en al in meerdere projecten gebruikt heb.
// Ik ga niet de hele class uitleggen, als je dat wilt spreek je me maar aan tijdens de les.
// In plaats daarvan zal ik de hoofdelementen toelichten zodat je de class wel kan gebruiken.
// Als je dat doet echter, gelieve dan wel mijn naam te vermelden. Bij vragen kun je altijd
// contact met me opnemen: bobrubbens [at] gmail [dot] com

// De class is gemaakt vanuit dit idee: je maakt de class 1 keer aan, waarbij de class bij aanmaak
// alle essentile dingen maakt/opslaat: hij maakt hier de tekst van de knop en slaat hier de
// parameters op (startpositie, knoppositie, of hij uitgelijnd moet worden, etc. De align-parameter lijnt alle
// knoppen uit op een bepaald x cordinaat: deze kun je aanpassen in de constructor.

// Vervolgens kun je de knop gaan gebruiken. Daar zijn drie functies essentiel voor: logic, render, getButtonState.

// Logic doet het logische gedeelte van de knop. Je geeft als parameters de coordinaten van de muis, en
// de mousestate die je van SDL kreeg, zodat de functie kan bepalen of de knop ingedrukt wordt e.d.
// Deze functie geeft de knopstatus terug (of hij ingedrukt wordt of niet), deze zijn gedefinieerd volgens
// de constanten onderaan de pagina (B_CLICK enzo). Je hoeft hem niet op te slaan; de functie getButtonState
// geeft de knopstatus ook terug

// Render doet niks anders dan renderen.

// Vergeet vervolgens de knop niet te verwijderen als je hem met new aangemaakt hebt! Anders gaat dat vanzelf als
// je de scope uit gaat.

class cButton {
private:
    SDL_Rect propsStandard, propsHeader, propsCurrent;    // propsStandard is the default position of the button.
                                            // propsHeader is the position of the button when it is a header.
                                            // propsCurrent is used when the button is moving to a new position.
    std::string caption;                    // Contains the caption.
    int targetState, currentState;          // Contains the state which it is currently in: fading out, fading
                                            // in, moving to the header position, etc.
    int visibleState;
    int buttonState;                        // Contains the state which the button is currently in: neutral,
                                            // mouse hovering over, clicked.
    int startTimeM;                          // When the button started animating
    int startTimeV;                         // For faing in/out
    SDL_Surface* captionSurface;            // Contains the surface with the button text.
    SDL_Surface* captionSurfaceH;           // Contains the surface with the button text when the mouse hovers over.
    SDL_Surface* fadeSurface;               // Surface used for fading in and out.

public:
    cButton(std::string caption, int x, int y, bool align, TTF_Font* font, int visibleStateF, int position); // Constructor, sets all the custom variables and does a lot
                                            // in advance (like calculating header position, generating button
                                            // text, that kinda stuff).
    ~cButton();                             // Destroys EVERYTHING! MWUHAHAHA.

    int setState(int state);
    int reset();                            // Resets the button: makes it fade in or move in from header position.
                                            // And sets the state to neutral.
    int makeHeader();                       // Sets the state to header.
    int makeStandard();
    int fadeIn();
    int fadeOut();                          // Sets the state to faded out.
    int logic(int mX, int mY, Uint8 mouseState); // Handles input,fading it in/out and moving it
    int render();                           // renders
                                            // to/from the header position.
    int getState();                         // Returns the static state or of applicable the dynamic state.
                                            // Static state is for instance at header positon, or invisible.
                                            // Dynamic state means for instance fading out, or moving from header
                                            // position to neutral position.
    int getVisible();
    int getButtonState();                     // Returns the button state (clicked/hovering/neutral)
    int getProps();                         // Returns x/y depending which state is given (header or menu state)
                                            // and always returns the same width and height.
    std::string getText();                  // Returns the button caption.
} ;

// Button Constants
const int B_NULL = 0;
const int B_NEUTRAL = 1;
const int B_HOVER = 2;
const int B_CLICK = 3;

const int B_FADINGOUT = 4;
const int B_FADINGIN = 5;
const int B_TOHEADER = 6;
const int B_TOSTANDARD = 7;

const int B_HEADER = 8;
const int B_STANDARD = 9;
const int B_INVISIBLE = 10;
const int B_VISIBLE = 11;

const float B_MS = 500; // The amount of milliseconds the animation is going to take

#endif
