

#include "cControls.h"
#include "constants.h"
#include "cSnake.h"
#include "functions.h"
#include "globals.h"

cControls::cControls() {
    snake = new cSnake(1, false, 4);

    dirA[0] = left;
    dirA[1] = top;
    dirA[2] = right;
    dirA[3] = bottom;

    dir = 0;
    moveCount = 0;

    noKey = NULL;

    key.push_back(loadImage("Media/leftkey.png"));
    key.push_back(loadImage("Media/upkey.png"));
    key.push_back(loadImage("Media/rightkey.png"));
    key.push_back(loadImage("Media/downkey.png"));
    noKey = loadImage("Media/nokeys.png");

    if (noKey == NULL) {
        gm->setNextState(STATE_EXIT);
    }

    isPressed = SDL_GetTicks();

    header = TTF_RenderText_Shaded(fSpecial, "Pijltjestoetsen", clrBlack, clrWhite);
    comment1 = TTF_RenderText_Shaded(fNormal, "Het spel wordt volledig bestuurd", clrBlack, clrWhite);
    comment2 = TTF_RenderText_Shaded(fNormal, "met de pijltjestoetsen.", clrBlack, clrWhite);
}

cControls::~cControls() {
    delete snake;

    SDL_FreeSurface(header);
    SDL_FreeSurface(comment1);
    SDL_FreeSurface(comment2);

    for (int i = 0; i < 4; i++) {
        SDL_FreeSurface(key[i]);
    }
    SDL_FreeSurface(noKey);
}

int cControls::logic() {
    if (snake->logic(dirA[dir], false) == 2) {
        moveCount++;
    }

    if (moveCount == 7) {
        moveCount = 0;
        dir++;
        if (dir > 3) dir = 0;
        isPressed = SDL_GetTicks();
    }

    return 0;
}

int cControls::render() {
    if (SDL_GetTicks() - isPressed < 1500) {
        applySurface(key[dir], screen, 150, 150);
    } else {
        applySurface(noKey, screen, 150, 150);
    }

    applySurface(header, screen, (SCR_W - header->w) / 2, 90);
    applySurface(comment1, screen, (SCR_W - comment1->w) / 2, 450);
    applySurface(comment2, screen, (SCR_W - comment2->w) / 2, 490);

    snake->render();

    return 0;
}
