#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>

#include "cHighscores.h"
#include "constants.h"
#include "functions.h"
#include "globals.h"

int cHighscores::logic() {

    return 0;
}

int cHighscores::render() {
    SDL_Surface* sName;
    SDL_Surface* sScore;
    std::string tS;
    std::stringstream ss;
    int c;

    sName = TTF_RenderText_Shaded(fSpecial, "Highscores", clrBlack, clrWhite);
    applySurface(sName, screen, SCR_W - sName->w, 0);

    for (int i = 0; i < 10; i++) {
        c = 128 - (i / 9.0 * 128.0);
        SDL_Color clr = {c, c, c};

        ss.str("");
        ss.clear();
        ss << i + 1 << ". " << names[i];
        sName = TTF_RenderText_Shaded(fNormal, ss.str().c_str(), clr, clrWhite);

        ss.str("");
        ss.clear();
        ss << scores[i];

        sScore = TTF_RenderText_Shaded(fNormal, ss.str().c_str(), clr, clrWhite);

        applySurface(sName, screen, 0, i * 40 + 100);
        applySurface(sScore, screen, SCR_W - sScore->w, i * 40 + 100);

        SDL_FreeSurface(sName);
        SDL_FreeSurface(sScore);
    }

    return 0;
}

int cHighscores::importScores() {
    std::ifstream fiScore;
    std::string tName;
    std::string tScore;

    fiScore.open("Media/highscores.txt");
    names.clear();
    scores.clear();

    if (fiScore.is_open()) {
        int tI;

        for (int i = 0; i < 10; i++) {
            getline(fiScore, tName);
            getline(fiScore, tScore);

            std::stringstream(tScore) >> tI;

            names.push_back(tName);
            scores.push_back(tI);
        }

        fiScore.close();
    } else {
        genNewHighscores();
    }
    return 0;
}

int cHighscores::exportScores() {
    std::ofstream fiScore;

    fiScore.open("Media/highscores.txt");

    for (int i = 0; i < 10; i++) {
        fiScore << names[i] << std::endl;
        fiScore << scores[i] << std::endl;
    }

    fiScore.close();

    return 0;
}

int cHighscores::genNewHighscores() {
    names.clear();
    scores.clear();

    names.push_back("Wilbur");
    scores.push_back(100);

    names.push_back("Homer");
    scores.push_back(90);

    names.push_back("Evelyn");
    scores.push_back(80);

    names.push_back("Ninny");
    scores.push_back(70);

    names.push_back("Idgie");
    scores.push_back(60);

    names.push_back("Wally");
    scores.push_back(50);

    names.push_back("Fuzzy");
    scores.push_back(40);

    names.push_back("Artemis");
    scores.push_back(30);

    names.push_back("Harry");
    scores.push_back(20);

    names.push_back("Katadreuffe");
    scores.push_back(10);

    exportScores();

    return 0;
}

int cHighscores::addScore(std::string name, int score) {
    if (name == "") return 0;

    for (size_t i = 0; i < 10; i++) {
        if (score > scores[i]) {
            names.insert(names.begin() + i, name);
            scores.insert(scores.begin() + i, score);
            break;
        }
    }

    names.resize(10, "Je Moeder");
    scores.resize(10, -1);

    exportScores();

    return 0;
}

cHighscores::cHighscores() {
    importScores();
}

cHighscores::~cHighscores() {
    exportScores();
}
