

#include "button.h"
#include "cGame.h"
#include "constants.h"
#include "cPaused.h"
#include "functions.h"
#include "globals.h"

int cPaused::logic(int mX, int mY, Uint8 mouseState) {
    if (bResume->logic(mX, mY, mouseState) == B_CLICK) {
        return 1;
    }

    if (bQuit->logic(mX, mY, mouseState) == B_CLICK) {
        return 2;
    }

    return 0;
}

int cPaused::render(cGame* curGM) {
    curGM->render();

    // Fade
    const SDL_PixelFormat& fmt = *(screen->format);
    SDL_Surface* tS = SDL_CreateRGBSurface(SDL_SWSURFACE, SCR_W, SCR_H, fmt.BitsPerPixel, fmt.Rmask, fmt.Gmask, fmt.Bmask, fmt.Amask);
    SDL_FillRect(tS, NULL, SDL_MapRGBA(tS->format, 255, 255, 255, 0));
    SDL_SetAlpha(tS, SDL_SRCALPHA, 200);
    applySurface(tS, screen, 0, 0);
    SDL_FreeSurface(tS);

    bResume->render();
    bQuit->render();

    return 0;
}

cPaused::cPaused() {
    bResume = new cButton("Hervatten", 0, 200, true, fNormal, B_VISIBLE, B_STANDARD);
    bQuit = new cButton("Stoppen", 0, 250, true, fNormal, B_VISIBLE, B_STANDARD);
}

cPaused::~cPaused() {
    delete bResume;
    delete bQuit;
}
