

#include "cSnake.h"
#include "functions.h"
#include "globals.h"

int cSBody::logic(bool step, eDirection direction, int hX, int hY) {
    int tx, ty;

    /*
    switch (curDir) {
        case top:
            if (direction != bottom) {curDir = direction;}
            break;
        case bottom:
            if (direction != top) {curDir = direction;}
            break;
        case left:
            if (direction != right) {curDir = direction;}
            break;
        case right:
            if (direction != left) {curDir = direction;}
            break;
    }
    */

    curDir = direction;

    int retVal = 0;

    if (step) {
        tx = prevX;
        ty = prevY;

        prevX = x;
        prevY = y;

        if (isHead) {
            switch (curDir) {
                case top:
                    y--;
                    break;
                case bottom:
                    y++;
                    break;
                case left:
                    x--;
                    break;
                case right:
                    x++;
                    break;
            }

            if (x < 0 || x > 47 || y < 0 || y > 47) {
                if (walls) {
                    retVal = 1;

                    x = prevX;
                    y = prevY;
                    prevX = tx;
                    prevY = ty;
                } else {
                    if (x < 0) {
                        x = 47;
                    } else if (x > 47) {
                        x = 0;
                    } else if (y < 0) {
                        y = 47;
                    } else if (y > 47) {
                        y = 0;
                    }
                }
            }
        } else {
            // Pak de vorige positie van de parent
            x = parent->gPrevX();
            y = parent->gPrevY();

            if (x == hX && y == hY) {
                retVal = 3;

                x = prevX;
                y = prevY;
                prevX = tx;
                prevY = ty;
            }
        }
    } else {
        // Geen stapje vooruit
    }

    return retVal;
}

int cSBody::render() {
    if (isHead) {
        // Kies een van de hoofden uit het plaatje en plak deze op de juiste plek
        SDL_Surface* t;
        switch (curDir) {
            case top:
                t = sHeadU;
                break;
            case right:
                t = sHeadR;
                break;
            case bottom:
                t = sHeadD;
                break;
            case left:
                t = sHeadL;
                break;
        }

        applySurface(t, screen, 10 + x * BODY_SIZE, 110 + y * BODY_SIZE);
    } else {
        SDL_Rect t;
        t.x = 10 + x * BODY_SIZE;
        t.y = 110 + y * BODY_SIZE;
        t.w = BODY_SIZE;
        t.h = t.w;

        // SDL_FillRect(screen, &t, SDL_MapRGB(screen->format, 0, 0, 0));

        int border = 2;

        t.x = 10 + x * BODY_SIZE + border;
        t.y = 110 + y * BODY_SIZE + border;
        t.w = BODY_SIZE - 2 * border;
        t.h = t.w;

        SDL_FillRect(screen, &t, SDL_MapRGB(screen->format, 0, 0, 0));
    }

    return 0;
}

int cSBody::gX() {
    return x;
}

int cSBody::gY() {
    return y;
}

int cSBody::gPrevX() {
    return prevX;
}

int cSBody::gPrevY() {
    return prevY;
}

eDirection cSBody::setDirection(eDirection direction) {
    curDir = direction;
    return top;
}

eDirection cSBody::getDirection() {
    return curDir;
}

cSBody::cSBody(cSBody* parentBody, int sX, int sY, bool isHeadF, eDirection startDir, bool wallsF) {
    curDir = startDir;

    walls = wallsF;

    isHead = isHeadF;

    if (isHead) {
        sHeadU = loadImage("Media/snakeHeadU.png");
        sHeadR = loadImage("Media/snakeHeadR.png");
        sHeadD = loadImage("Media/snakeHeadD.png");
        sHeadL = loadImage("Media/snakeHeadL.png");
    }

    parent = parentBody;
    x = sX;
    y = sY;
    prevX = x;
    prevY = y;
}

cSBody::~cSBody() {
    if (isHead) {
        SDL_FreeSurface(sHeadU);
        SDL_FreeSurface(sHeadR);
        SDL_FreeSurface(sHeadD);
        SDL_FreeSurface(sHeadL);
    }
}
