#include "mtwist.h"

#include "cSnake.h"
#include "cTargetMan.h"

int cSnake::logic(eDirection direction, bool random) {
    bool step = false;
    int retVal = 0;
    eDirection dirMod;

    if (!paused) {
        if (SDL_GetTicks() - lastUpdate >= delay) {
            step = true;
            moved = true;
            lastUpdate = SDL_GetTicks();
            retVal = 2;
        }

        if (step == false) {
            moved = false;
        }

        if (((body[0]->gX() < head->gX()) || (body[0]->gX() == 47 && head->gX() == 0)) && direction == left) {
            dirMod = head->getDirection();
        } else if ((body[0]->gX() > head->gX() || body[0]->gX() == 0 && head->gX() == 47) && direction == right) {
            dirMod = head->getDirection();
        } else if ((body[0]->gY() < head->gY() || body[0]->gY() == 47 && head->gY() == 0) && direction == top) {
            dirMod = head->getDirection();
        } else if ((body[0]->gY() > head->gY() || body[0]->gY() == 0 && head->gY() == 47) && direction == bottom) {
            dirMod = head->getDirection();
        } else {
            dirMod = direction;
        }

        if (head->logic(step, dirMod, 0, 0) == 1) {
            retVal = 1;
        }

        for (int i = 0; i < body.size(); i++) {
            if (body[i]->logic(step, dirMod, head->gX(), head->gY()) == 3) {
                retVal = 3;
            }
        }

    } else {
        // Gepauzeerd!
    }

    return retVal;
}

int cSnake::render() {
    head->render();

    for (int i = 0; i < body.size(); i++) {
            body[i]->render();
    }
    return 0;
}

int cSnake::pause() {
    paused = true;

    return 0;
}

int cSnake::resume() {
    paused = false;
    lastUpdate = SDL_GetTicks();

    return 0;
}

int cSnake::add1() {
    int bMax = body.size() - 1;
    int tx = body[bMax]->gX();
    int ty = body[bMax]->gY();

    body.push_back(new cSBody(body[bMax], tx, ty, false, top, walls));

    return 0;
}

int cSnake::gHX() {
    return head->gX();
}

int cSnake::gHY() {
    return head->gY();
}

bool cSnake::posInBody(int x, int y) {
    for (int i = 0; i < body.size(); i++) {
        if (x == body[i]->gX() && y == body[i]->gY()) {
            return true;
        }
    }

    if (head->gX() == x && head->gY() == y) {
        return true;
    }

    return false;
}

bool cSnake::gMoved() {
    return moved;
}

bool cSnake::gWalls() {
    return walls;
}

eDirection cSnake::getDir() {
    return head->getDirection();
}

cSnake::cSnake(int difficulty, bool wallsF, int amount) {
    switch (difficulty) {
        case 1:
            delay = 500;
            break;
        case 2:
            delay = 200;
            break;
        case 3:
            delay = 50;
            break;
    }

    if (amount == 4) {
        head = new cSBody(NULL, 27, 30, true, left, wallsF);
        body.push_back(new cSBody(head, 28, 30, false, top, walls));
        body.push_back(new cSBody(body[0], 29, 30, false, top, walls));
    } else {
        head = new cSBody(NULL, 23, 26, true, left, wallsF);
        body.push_back(new cSBody(head, 24, 26, false, top, walls));
        body.push_back(new cSBody(body[0], 25, 26, false, top, walls));
    }

    int amountMod = amount - 2;

    while (amountMod != 0) {
        add1();
        amountMod--;
    }

    lastUpdate = 0;
    paused = false;
    walls = wallsF;

    moved = false;
}

cSnake::~cSnake() {
    delete head;

    for (int i = 0; i < body.size(); i++) {
        delete body[i];
    }
}
