#ifndef CSNAKE_H
#define CSNAKE_H

#include <vector>
#include <SDL/SDL.h>

const int BODY_SIZE = 10;
const int FIELD_SIZE = 48;

enum eDirection {
    top = 1,
    right,
    bottom,
    left,
} ;

class cSBody {
public:
    int logic(bool step, eDirection direction, int hX, int hY);
    int render();

    cSBody(cSBody* parentBody, int sX, int sY, bool isHead, eDirection startDir, bool wallsF);
    ~cSBody();

    int gX();
    int gY();
    int gPrevX();
    int gPrevY();

    eDirection setDirection(eDirection direction);
    eDirection getDirection();

private:
    bool isHead;
    bool walls;
    eDirection curDir;

    SDL_Surface* sHeadU;
    SDL_Surface* sHeadR;
    SDL_Surface* sHeadD;
    SDL_Surface* sHeadL;

    cSBody* parent;
    int x, y;
    int prevX, prevY;

} ;

class cSnake {
public:
    cSnake(int difficulty, bool wallsF, int amount);
    ~cSnake();

    int logic(eDirection direction, bool random);
    int render();
    int pause();
    int resume();
    int add1();

    int gHX();
    int gHY();
    bool gMoved();
    bool posInBody(int x, int y);

    eDirection getDir();
    bool gWalls();

private:
    cSBody* head;
    std::vector<cSBody*> body;

    bool moved;

    bool paused;
    bool walls;
    int lastUpdate;
    int delay;

} ;

#endif
