#include "mtwist.h"
#include <sstream>
#include <string>

#include "cSnake.h"
#include "cTargetMan.h"
#include "functions.h"
#include "globals.h"

cTargetMan::cTargetMan(int* scrPtr, int difficulty) {
    movesLeft = 0;
    mouseCount = 5;

    mouseX = 10;
    mouseY = 26;

    scorePtr = scrPtr;
    diff = difficulty;

    sMouse = NULL;
    sPill = NULL;

    sMouse = loadImage("Media/muis.png");
    sPill = loadImage("Media/pil.png");
}

cTargetMan::~cTargetMan() {
    SDL_FreeSurface(sMouse);
    SDL_FreeSurface(sPill);
}

int cTargetMan::logic(cSnake* snake) {
    if (snake->gMoved() == true && movesLeft > 0) {
        movesLeft--;
    }

    if (snake->gHX() == pillX && snake->gHY() == pillY && movesLeft > 0) {
        switch(diff) {
            case 1:
                *scorePtr += 5;
                break;
            case 2:
                *scorePtr += 50;
                break;
            case 3:
                *scorePtr += 100;
                break;
        }

        movesLeft = 0;

        snake->add1();
    } else if (snake->gHX() == mouseX && snake->gHY() == mouseY) {
        switch(diff) {
            case 1:
                *scorePtr += 1;
                break;
            case 2:
                *scorePtr += 10;
                break;
            case 3:
                *scorePtr += 20;
                break;
        }

        mouseCount--;

        int nX = mt_lrand() % 48;
        int nY = mt_lrand() % 48;

        while (snake->posInBody(nX, nY)) {
            nX = mt_lrand() % 48;
            nY = mt_lrand() % 48;
        }

        mouseX = nX; mouseY = nY;

        snake->add1();
    }

    if (mouseCount == 0) {
        movesLeft = 52;
        mouseCount = 5 + mt_lrand() % 6;

        int nX = mt_lrand() % 48;
        int nY = mt_lrand() % 48;

        while (snake->posInBody(nX, nY)) {
            nX = mt_lrand() % 48;
            nY = mt_lrand() % 48;
        }

        pillX = nX; pillY = nY;
    }

    return 0;
}

int cTargetMan::render() {
    if (movesLeft > 0) {
        // Pill
        applySurface(sPill, screen, pillX * 10 + 10, pillY * 10 + 110);

        SDL_Rect t;
        t.x = 215;
        t.y = 92;
        t.w = movesLeft / 52.0 * 200.0;
        t.h = 6;

        SDL_FillRect(screen, &t, SDL_MapRGB(screen->format, (52 - movesLeft) / 50.0 * 255, 0, 0));
        applySurface(sPill, screen, 200, 90);
    }

    // mouse
    applySurface(sMouse, screen, mouseX * 10 + 10, mouseY * 10 + 110);

    return 0;
}
