#include <SDL/SDL.h>

#include "checkboxes.h"

int cCheckboxes::logic(int mX, int mY, int mouseState) {
    for (int i = 0; i < checkboxes.size(); i++) {
        if (checkboxes[i].logic(mX, mY, mouseState) == CHECK_TURNON) {
            for (int j = 0; j < checkboxes.size(); j++) {
                if (j != i) {
                    checkboxes[j].setState(CHECK_OFF);
                }
            }
        };
    }
    return 0;
}

int cCheckboxes::render() {
    for (int i = 0; i < checkboxes.size(); i++) {
        checkboxes[i].render();
    }
    return 0;
}

int cCheckboxes::getSelected() {
    int retVal = 0;
    for (int i = 0; i < checkboxes.size(); i++) {
        if (checkboxes[i].getState() == CHECK_ON) {
            retVal = i + 1;
            break;
        }
    }
    return retVal;
}

int cCheckboxes::setSelected(int p) {
    for (int i = 0; i < checkboxes.size(); i++) {
        if (i + 1 == p) {
            for (int j = 0; j < checkboxes.size(); j++) {
                if (i != j) {
                    checkboxes[j].setState(CHECK_OFF);
                } else {
                    checkboxes[j].setState(CHECK_ON);
                }
            }

            break;
        }
    }

    if (p == 0) {
        for (int j = 0; j < checkboxes.size(); j++) {
            checkboxes[j].setState(CHECK_OFF);
        }
    }

    return 0;
}

cCheckboxes::cCheckboxes(int x, int y, int step, bool horizontal, int amount, int checkWidth, int checkBorder) {
    checkboxes.clear();
    bool first = true;

    for (int i = 0; i < amount; i++) {
        if (horizontal) {
            checkboxes.push_back(cCheckbox(x + step * i, y, checkWidth, checkBorder, CHECK_OFF));
        } else {
            checkboxes.push_back(cCheckbox(x, y + step * i, checkWidth, checkBorder, CHECK_OFF));
        }

        if (first) {
            checkboxes[0].setState(CHECK_ON);
        }
    }

}

cCheckboxes::~cCheckboxes() {

}
