#include <SDL/SDL.h>
#include "mtwist.h"

#include "button.h"
#include "checkboxes.h"
#include "cSnake.h"
#include "functions.h"
#include "gamestates.h"
#include "globals.h"

int gsIntro::logic() {
    if (bTest->logic(mX, mY, mouseState) == B_CLICK) {
        gm->setNextState(STATE_MENU);
    }

    // Elke 1 seconden verander richting
    int r;

    if (SDL_GetTicks() - lastChange >= delay) {
        r = mt_lrand() % 4;
        switch (r) {
            case 0:
                dir = top;
                break;
            case 1:
                dir = right;
                break;
            case 2:
                dir = bottom;
                break;
            case 3:
                dir = left;
                break;
        }

        lastChange = SDL_GetTicks();
        delay = mt_lrand() % 400 + 300;
    }

    eDirection cDir = snake->getDir();
    eDirection notDir;

    switch (cDir) {
        case top:
            notDir = bottom;
            break;
        case bottom:
            notDir = top;
            break;
        case left:
            notDir = right;
            break;
        case right:
            notDir = left;
            break;
    }

    while (dir == notDir) {
        r = mt_lrand() % 4;
        switch (r) {
            case 0:
                dir = top;
                break;
            case 1:
                dir = right;
                break;
            case 2:
                dir = bottom;
                break;
            case 3:
                dir = left;
                break;
        }
    }

    if (snake->logic(dir, false) == 4) {
        dir = snake->getDir();
    }

    return 0;
}

int gsIntro::render() {
    SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format, 255, 255, 255));

    bTest->render();

    snake->render();

    na();

    SDL_Flip(screen);

    return 0;
}

gsIntro::gsIntro() {
    bTest = new cButton(">> Start Snake+ <<", 11, 10, false, fSpecial, B_VISIBLE, B_STANDARD);

    snake = new cSnake(3, false, 10);
    dir = left;
    lastChange = SDL_GetTicks();
    delay = 500;
}

gsIntro::~gsIntro() {
    delete bTest;

    delete snake;
}
