#include <SDL/SDL.h>
#include "mtwist.h"
#include "randistrs.h"

#include "constants.h"
#include "functions.h"
#include "gamestate.h"
#include "gamestates.h"
#include "globals.h"

// Tellertje voor pillen (hoe lang de pil er nog is)
// Scorescherm met 10 highscores + score toevoeg functie
// How to, about, etc.

int init() {
    SDL_Init(SDL_INIT_TIMER | SDL_INIT_VIDEO);  // Hier wordt de basis voor de SDL engine gestart. Ik geef aan dat ik
                                                // alleen gebruikt ga maken van het timer systeem en het video systeem.
                                                // De andere systemen initialiseerd hij niet, wat rekenkracht scheelt.

    screen = SDL_SetVideoMode(SCR_W, SCR_H, SCR_BPP, SDL_SWSURFACE);    // Hier wordt een schermpje gemaakt.
                                                                        // Ik krijg een pointer naar het beeldscherm zodat ik het kan gaan bewerken.

    SDL_WM_SetCaption("Snake+ by Bob Rubbens", NULL); // Hiermee stel ik de naam van het scherm in

    TTF_Init(); // Hier start ik het letter-systeem op, wat ervoor zorgt dat ik op het scherm kan schrijven.

    fNormal = TTF_OpenFont("Media/db_quarz_mix.ttf", 60); // Hier laat ik een lettertype met grootte van 60 pixels.

    fSpecial = TTF_OpenFont("Media/db_quarz_mix.ttf", 120);

    fBig = TTF_OpenFont("Media/db_quarz_mix.ttf", 400);

    fTag = TTF_OpenFont("Media/db_quarz_mix.ttf", 30);

    fTagP = TTF_OpenFont("Media/db_quarz_mix.ttf", 40);

    mt_seed(); // Hier seed ik de RNG (random number generator)

    gm = new cGameMan(STATE_INTRO); // Hier maak ik een nieuwe gamestate manager. Merk op: dynamisch toegewezen geheugen, moet ik
                                    // dus zelf verwijderen!

    // freopen( "CON", "wt", stdout );
    // freopen( "CON", "wt", stderr );

    return 0;
}

int game() {
    while (gm->getState() != STATE_EXIT) { // Kijk of de gamestate aangeeft dat er afgesloten moet worden
        gm->currState->input();    // Hier run ik gewoon de gedeeltes die elke gamestate per definitie bevat.
                                        // Eerst verkrijg ik input, dan voer ik alle berekeningen uit en vervolgens print ik alles op het scherm.
        gm->currState->logic();    // Dan geef ik nog aan voor het systeem (SDL_Delay(1)) dat ik niet alle processortijd nodig heb
                                        // en het systeem wel even wat dingen mag regelen.
        gm->currState->render();

        // SDL_Delay(1);

        gm->changeState();         // Op het laatst check ik hier of de spelsituatie nog aangepast moet worden. Zo ja, dan gebeurd dat hier. Zo nee, dan gebeurt er niks.
    }

    return 0;
}

int quit() { // In deze functie worden alle systemen afgesloten en het dynamisch toegewezen geheugen opgeruimd.
    delete gm;

    TTF_CloseFont(fNormal);
    TTF_CloseFont(fTag);
    TTF_CloseFont(fTagP);

    TTF_Quit();

    SDL_Quit();

    return 0;
}

int main(int argc, char *argv[]) { // Hier begint het programma!
    init(); // Hier worden alle globale systemen geinitialiseerd

    game(); // Hier vind het daadwerkelijke spel plaats; de menu's, het spel, score, uitleg, alles

    quit(); // Hier worden de globale resources (globaal dynamisch toegewezen geheugen) opgeruimd

    return 0;
}
